from Acquisition import Implicit
from Persistence import Persistent
from AccessControl.Role import RoleManager
from StructuredText import Basic, Document, HTML, DocBookChapter
from OFS.SimpleItem import Item
from OFS import History
from Globals import HTMLFile, MessageDialog

from AccessControl import allow_class

from Globals import DTMLFile
from Products.PageTemplates.PageTemplateFile import PageTemplateFile
from ImageFile import ImageFile
import glob

import MailAccount


def manage_addWebmail(self, id, title='', REQUEST=None):
    """ add a ZWebmail """

    id=str(id)
    title=str(title)

    t=ZWebmail(id, title)
    self._setObject(id, t)
    if REQUEST is not None:
        return self.manage_main(self, REQUEST)
    
manage_addWebmailForm = HTMLFile('addWebmail', globals())


allow_class(MailAccount.Mimepart)
allow_class(MailAccount.Mail)
allow_class(MailAccount.MailAccount)


class ZWebmail(Implicit, Item, Persistent, History.Historical):

    """ A ZWebmail object """

    meta_type = 'ZWebmail'

    manage_options=(
    (
        {'label':'Edit', 'action':'manage_webmail'},
        {'label':'View', 'action':'index_html'},
        )
    +History.Historical.manage_options
    +Item.manage_options
    )

    manage_webmail = DTMLFile('www/manage_webmail', globals())
    
    index_html = PageTemplateFile('www/webmail_login', globals())
    boite = PageTemplateFile('www/webmail_extract', globals())
    message = PageTemplateFile('www/message_view', globals())
    attachment = PageTemplateFile('www/part_view', globals())
    reply = PageTemplateFile('www/message_reply', globals())
    delete = PageTemplateFile('www/message_delete', globals())

    webmail_css = DTMLFile('www/webmail_css', globals())
    compose_icon = ImageFile('www/images/compose.gif', globals())
    reply_icon = ImageFile('www/images/reply.gif', globals())
    delete_icon = ImageFile('www/images/delete.gif', globals())
    logout_icon = ImageFile('www/images/logout.gif', globals())

    # import mime icons
    mime_multipart = ImageFile('www/images/mime/mime_multipart.gif', globals())
    mime_text = ImageFile('www/images/mime/mime_text.gif', globals())
    mime_html = ImageFile('www/images/mime/mime_html.gif', globals())
    mime_mail = ImageFile('www/images/mime/mime_mail.gif', globals())
    mime_image = ImageFile('www/images/mime/mime_image.gif', globals())
    mime_unknown = ImageFile('www/images/mime/mime_unknown.gif', globals())
                   
    __ac_permissions__=(
        ('View management screens',
         ('manage_editForm', 'manage', 'manage_main', 'PrincipiaSearchSource')),

        ('Change ZWebmail',
         ('manage_edit', 'PUT')),

        ('View',
         ('index_html', '')),
        )


    def __init__(self, id, title='', host='127.0.0.1', REQUEST=None):
        self.id = id
        self.host = host
        self.manage_edit(title, None)
        
    def manage_edit(self, title='', REQUEST=None):
        """ at least one doc string gets me every time. """
        self.title=title
        if REQUEST is not None:
            return self.manage_main(self, REQUEST)

    def login(self, login, password, REQUEST):
        """ login the user """
        session = REQUEST.SESSION
        session['account'] = MailAccount.MailAccount(self.host, login, password)
        return REQUEST.RESPONSE.redirect(self.absolute_url()+'/boite')
        
    def post_delete(self, id, REQUEST):
        """ delete a post """
        session = REQUEST.SESSION
        session['account'].deleteMessage(id)
        return REQUEST.RESPONSE.redirect(self.absolute_url()+'/boite')
        
    def post_reply(self, by, to, subject, content, REQUEST):
        """ send a reply to a post """
        session = REQUEST.SESSION
        session['account'].sendMessage(by, to, subject, content)
        return REQUEST.RESPONSE.redirect(self.absolute_url()+'/boite')

    def part(self, id, REQUEST):
        """ fetch a message part """
        session = REQUEST.SESSION
        message_id, part_id = id.split("_part_")
        message = session['account'].getMessage(message_id)
        result = message.part
        while len(part_id):
            number = part_id
            if part_id.find('_') >= 0:
                number, part_id = part_id.split('_')
            else:
                part_id = ''
            result = result.getParts()[int(number)]
        REQUEST.RESPONSE.setHeader('Content-type',result['type'])
        return result.message

    def logout(self, REQUEST):
        """ fetch a message part """
        session = REQUEST.SESSION
        message = session.delete('account')
        return REQUEST.RESPONSE.redirect(self.absolute_url()+'/')
        

## Globals.default__class_init__(ZWebmail)





